/*
    Copyright (c) 2007 SIEGE Development Team
    All rights reserved.
    
    This file is part of libSIEGE.
    
    This software is copyrighted work licensed under the terms of the
    2-clause BSD license. Please consult the file "license.txt" for
    details.
    
    If you did not recieve the file with this program, please email
    Tim Chas <darkuranium@gmail.com>.
*/

#ifndef __PYS_CORE_ENTITY_H__
#define __PYS_CORE_ENTITY_H__

#include "../common.h"

#include "../audio/source.h"
#include "../graphics/sprite.h"

typedef struct PysPhysicsBody
{
    PyObject_HEAD
    SGPhysicsBody* body;
} PysPhysicsBody;

typedef struct PysEntity
{
    PyObject_HEAD
    PysSprite* sprite;
    PysSprite* mask;
    PysPhysicsBody* body;
    PysSource* source;
    SGEntity* entity;
} PysEntity;

int pysEntityCheck(PyObject* o);
void sgpyInitCoreEntity(PyObject* parent);

#endif // __PYS_CORE_ENTITY_H__
